clang 10.0.0git

Macros | Functions
TextNodeDumper.cpp File Reference
`#include "clang/AST/TextNodeDumper.h"`
`#include "clang/AST/DeclFriend.h"`
`#include "clang/AST/DeclOpenMP.h"`
`#include "clang/AST/DeclTemplate.h"`
`#include "clang/AST/LocInfoType.h"`
`#include "clang/AST/DeclNodes.inc"`
`#include "clang/Basic/AttrList.inc"`
Include dependency graph for TextNodeDumper.cpp:

Go to the source code of this file.

## Macros
#define | DECL(DERIVED, BASE)
#define | ABSTRACT_DECL(DECL)
#define | ATTR(X)
#define | FLAG(fn, name)

## Functions
static void | dumpPreviousDeclImpl (raw_ostream &OS,...)
template<typename T >
static void | dumpPreviousDeclImpl (raw_ostream &OS, const Mergeable< T > *D)
template<typename T >
static void | dumpPreviousDeclImpl (raw_ostream &OS, const Redeclarable< T > *D)
static void | dumpPreviousDecl (raw_ostream &OS, const Decl *D)
| Dump the previous declaration in the redeclaration chain for a declaration, if any. More...
static void | dumpBasePath (raw_ostream &OS, const CastExpr *Node)

## Macro Definition Documentation

## ◆ ABSTRACT_DECL

#define ABSTRACT_DECL | ( |  | DECL | ) |

## ◆ ATTR

#define ATTR | ( |  | X | ) |

Value:
case attr::X: \
OS << #X; \
break;
X
X
Add a minimal nested name specifier fixit hint to allow lookup of a tag name from an outer enclosing ...
Definition: SemaDecl.cpp:14780

## ◆ DECL

#define DECL | ( |  | DERIVED,
|  |  | BASE
| ) |  |

Value:
case Decl::DERIVED: \
return dumpPreviousDeclImpl(OS, cast<DERIVED##Decl>(D));
dumpPreviousDeclImpl
static void dumpPreviousDeclImpl(raw_ostream &OS,...)
Definition: TextNodeDumper.cpp:21

## ◆ FLAG

#define FLAG | ( |  | fn,
|  |  | name
| ) |  |

Value:
if (D->fn()) \
OS << " " #name;
clang::transformer::name
RangeSelector name(std::string ID)
Given a node with a "name", (like NamedDecl, DeclRefExpr or CxxCtorInitializer) selects the name&#39;s to...
Definition: RangeSelector.cpp:186

Referenced by clang::TextNodeDumper::VisitCXXRecordDecl().

## Function Documentation

## ◆ dumpBasePath()

static void dumpBasePath | ( | raw_ostream & | OS,
|  | const CastExpr * | Node
| ) |  |
| static

Definition at line 629 of file TextNodeDumper.cpp.

References clang::Type::castAs(), clang::First, clang::CXXBaseSpecifier::getType(), clang::CXXBaseSpecifier::isVirtual(), clang::CastExpr::path_begin(), clang::CastExpr::path_empty(), and clang::CastExpr::path_end().

Referenced by clang::TextNodeDumper::VisitCastExpr(), and clang::TextNodeDumper::VisitCXXNamedCastExpr().

## ◆ dumpPreviousDecl()

static void dumpPreviousDecl | ( | raw_ostream & | OS,
|  | const Decl * | D
| ) |  |
| static

Dump the previous declaration in the redeclaration chain for a declaration, if any.

Definition at line 39 of file TextNodeDumper.cpp.

References clang::Decl::getKind().

Referenced by clang::TextNodeDumper::Visit().

## ◆ dumpPreviousDeclImpl() [1/3]

static void dumpPreviousDeclImpl | ( | raw_ostream & | OS,
|  |  | ...
| ) |  |
| static

Definition at line 21 of file TextNodeDumper.cpp.

## ◆ dumpPreviousDeclImpl() [2/3]

template<typename T >

static void dumpPreviousDeclImpl | ( | raw_ostream & | OS,
|  | const Mergeable< T > * | D
| ) |  |
| static

Definition at line 24 of file TextNodeDumper.cpp.

References clang::First, and clang::Mergeable< decl_type >::getFirstDecl().

## ◆ dumpPreviousDeclImpl() [3/3]

template<typename T >

static void dumpPreviousDeclImpl | ( | raw_ostream & | OS,
|  | const Redeclarable< T > * | D
| ) |  |
| static

Definition at line 31 of file TextNodeDumper.cpp.

References clang::Redeclarable< decl_type >::getPreviousDecl().